Index: /palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- /palm/trunk/SOURCE/spectra_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/spectra_mod.f90	(revision 4591)
@@ -1,36 +1,39 @@
 !> @file spectra_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
-! bugfix: preprocessor directives rearranged for serial mode
-! 
+! File re-formatted to follow the PALM coding standard
+!
+! 4429 2020-02-27 15:24:30Z raasch
+! Bugfix: preprocessor directives rearranged for serial mode
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
-! 
+!
 ! 3805 2019-03-20 15:26:35Z raasch
-! unused variable removed
-! 
+! Unused variable removed
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Renamed output variables
@@ -39,13 +42,12 @@
 ! Initial revision
 !
-!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculate horizontal spectra along x and y. 
-!> ATTENTION: 1d-decomposition along y still needs improvement, because in that
-!>            case the gridpoint number along z still depends on the PE number
-!>            because transpose_xz has to be used (and possibly also
-!>            transpose_zyd needs modification).
-!------------------------------------------------------------------------------!
+!> Calculate horizontal spectra along x and y.
+!> ATTENTION: 1d-decomposition along y still needs improvement, because in that case the gridpoint
+!>            number along z still depends on the PE number because transpose_xz has to be used
+!>            (and possibly also transpose_zyd needs modification).
+!--------------------------------------------------------------------------------------------------!
  MODULE spectra_mod
 
@@ -54,12 +56,11 @@
     PRIVATE
 
-    CHARACTER (LEN=2),  DIMENSION(10) ::  spectra_direction = 'x'
-    CHARACTER (LEN=10), DIMENSION(10) ::  data_output_sp  = ' '
-
-    INTEGER(iwp) ::  average_count_sp = 0
-    INTEGER(iwp) ::  dosp_time_count = 0
-    INTEGER(iwp) ::  n_sp_x = 0, n_sp_y = 0
-
-    INTEGER(iwp) ::  comp_spectra_level(100) = 999999
+    CHARACTER (LEN=10), DIMENSION(10) ::  data_output_sp  = ' '    !<
+    CHARACTER (LEN=2),  DIMENSION(10) ::  spectra_direction = 'x'  !<
+
+    INTEGER(iwp) ::  average_count_sp = 0              !<
+    INTEGER(iwp) ::  comp_spectra_level(100) = 999999  !<
+    INTEGER(iwp) ::  dosp_time_count = 0               !<
+    INTEGER(iwp) ::  n_sp_x = 0, n_sp_y = 0            !<
 
     LOGICAL ::  calculate_spectra   = .FALSE.  !< internal switch that spectra are calculated
@@ -70,7 +71,8 @@
     REAL(wp) ::  skip_time_dosp = 9999999.9_wp         !< no output of spectra data before this interval has passed
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  var_d
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  spectrum_x, spectrum_y
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  var_d  !<
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  spectrum_x  !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  spectrum_y  !<
 
     SAVE
@@ -110,180 +112,201 @@
     END INTERFACE spectra_parin
 
-    PUBLIC average_count_sp, averaging_interval_sp, calc_spectra,              &
-           calculate_spectra, comp_spectra_level, data_output_sp,              &
-           dosp_time_count, dt_dosp, n_sp_x, n_sp_y,                           &
-           skip_time_dosp, spectra_check_parameters, spectra_direction,        &
-           spectra_header, spectra_init, spectra_parin, spectrum_x,            &
-           spectrum_y, var_d
+    PUBLIC average_count_sp,                                                                       &
+           averaging_interval_sp,                                                                  &
+           calc_spectra,                                                                           &
+           calculate_spectra,                                                                      &
+           comp_spectra_level,                                                                     &
+           data_output_sp,                                                                         &
+           dosp_time_count,                                                                        &
+           dt_dosp,                                                                                &
+           n_sp_x,                                                                                 &
+           n_sp_y,                                                                                 &
+           skip_time_dosp,                                                                         &
+           spectra_check_parameters,                                                               &
+           spectra_direction,                                                                      &
+           spectra_header,                                                                         &
+           spectra_init,                                                                           &
+           spectra_parin,                                                                          &
+           spectrum_x,                                                                             &
+           spectrum_y,                                                                             &
+           var_d
 
 
  CONTAINS
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Parin for &spectra_par for calculating spectra
-!------------------------------------------------------------------------------!
-    SUBROUTINE spectra_parin
-
-       USE control_parameters,                                                 &
-           ONLY:  dt_data_output, message_string
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=80) ::  line  !< dummy string that contains the current  &
-                                    !< line of the parameter file
-
-       NAMELIST /spectra_par/  averaging_interval_sp, comp_spectra_level,      &
-                               data_output_sp, dt_dosp, skip_time_dosp,        &
-                               spectra_direction
-
-       NAMELIST /spectra_parameters/                                           &
-                               averaging_interval_sp, comp_spectra_level,      &
-                               data_output_sp, dt_dosp, skip_time_dosp,        &
-                               spectra_direction
-!
-!--    Position the namelist-file at the beginning (it was already opened in
-!--    parin), search for the namelist-group of the package and position the
-!--    file at this line.
-       line = ' '
-
-!
-!--    Try to find the spectra package
-       REWIND ( 11 )
-       line = ' '
-       DO WHILE ( INDEX( line, '&spectra_parameters' ) == 0 )
-          READ ( 11, '(A)', END=12 )  line
-       ENDDO
-       BACKSPACE ( 11 )
-
-!
-!--    Read namelist
-       READ ( 11, spectra_parameters, ERR = 10 )
-
-!
-!--    Default setting of dt_dosp here (instead of check_parameters), because
-!--    its current value is needed in init_pegrid
-       IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
-
-!
-!--    Set general switch that spectra shall be calculated
-       calculate_spectra = .TRUE.
-
-       GOTO 14
-
- 10    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'spectra_parameters', line )
-!
-!--    Try to find the old namelist
- 12    REWIND ( 11 )
-       line = ' '
-       DO WHILE ( INDEX( line, '&spectra_par' ) == 0 )
-          READ ( 11, '(A)', END=14 )  line
-       ENDDO
-       BACKSPACE ( 11 )
-
-!
-!--    Read namelist
-       READ ( 11, spectra_par, ERR = 13, END = 14 )
-
-       
-       message_string = 'namelist spectra_par is deprecated and will be ' // &
-                     'removed in near future. Please use namelist ' //       &
-                     'spectra_parameters instead'
-       CALL message( 'spectra_parin', 'PA0487', 0, 1, 0, 6, 0 )
-!
-!--    Default setting of dt_dosp here (instead of check_parameters), because
-!--    its current value is needed in init_pegrid
-       IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
-
-!
-!--    Set general switch that spectra shall be calculated
-       calculate_spectra = .TRUE.
-       
-       GOTO 14
-
- 13    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'spectra_par', line )
-       
-       
- 14    CONTINUE
-
-    END SUBROUTINE spectra_parin
-
-
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE spectra_parin
+
+    USE control_parameters,                                                                        &
+        ONLY:  dt_data_output,                                                                     &
+               message_string
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
+
+    NAMELIST /spectra_par/  averaging_interval_sp,                                                 &
+                            comp_spectra_level,                                                    &
+                            data_output_sp,                                                        &
+                            dt_dosp,                                                               &
+                            skip_time_dosp,                                                        &
+                            spectra_direction
+
+    NAMELIST /spectra_parameters/                                                                  &
+                            averaging_interval_sp,                                                 &
+                            comp_spectra_level,                                                    &
+                            data_output_sp,                                                        &
+                            dt_dosp,                                                               &
+                            skip_time_dosp,                                                        &
+                            spectra_direction
+!
+!-- Position the namelist-file at the beginning (it was already opened in parin), search for the
+!-- namelist-group of the package and position the file at this line.
+    line = ' '
+
+!
+!-- Try to find the spectra package
+    REWIND ( 11 )
+    line = ' '
+    DO WHILE ( INDEX( line, '&spectra_parameters' ) == 0 )
+       READ ( 11, '(A)', END=12 )  line
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read namelist
+    READ ( 11, spectra_parameters, ERR = 10 )
+
+!
+!-- Default setting of dt_dosp here (instead of check_parameters), because its current value is
+!-- needed in init_pegrid
+    IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
+
+!
+!-- Set general switch that spectra shall be calculated
+    calculate_spectra = .TRUE.
+
+    GOTO 14
+
+ 10 BACKSPACE( 11 )
+    READ( 11 , '(A)') line
+    CALL parin_fail_message( 'spectra_parameters', line )
+!
+!-- Try to find the old namelist
+ 12 REWIND ( 11 )
+    line = ' '
+    DO WHILE ( INDEX( line, '&spectra_par' ) == 0 )
+       READ ( 11, '(A)', END=14 )  line
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read namelist
+    READ ( 11, spectra_par, ERR = 13, END = 14 )
+
+
+    message_string = 'namelist spectra_par is deprecated and will be removed in near future.' //   &
+                     ' Please use namelist spectra_parameters instead'
+    CALL message( 'spectra_parin', 'PA0487', 0, 1, 0, 6, 0 )
+!
+!-- Default setting of dt_dosp here (instead of check_parameters), because its current value is
+!-- needed in init_pegrid
+    IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
+
+!
+!-- Set general switch that spectra shall be calculated
+    calculate_spectra = .TRUE.
+
+    GOTO 14
+
+ 13 BACKSPACE( 11 )
+    READ( 11 , '(A)') line
+    CALL parin_fail_message( 'spectra_par', line )
+
+
+ 14 CONTINUE
+
+ END SUBROUTINE spectra_parin
+
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Initialization of spectra related variables
-!------------------------------------------------------------------------------!
-    SUBROUTINE spectra_init
-
-       USE indices,                                                            &
-           ONLY:  nx, ny, nzb, nzt
-
-       IMPLICIT NONE
-
-       IF ( spectra_initialized )  RETURN
-
-       IF ( dt_dosp /= 9999999.9_wp )  THEN
-
-          IF ( .NOT. ALLOCATED( spectrum_x ) )  THEN
-             ALLOCATE( spectrum_x( 1:nx/2, 1:100, 1:10 ) )
-             spectrum_x = 0.0_wp
-          ENDIF
-
-          IF ( .NOT. ALLOCATED( spectrum_y ) )  THEN
-             ALLOCATE( spectrum_y( 1:ny/2, 1:100, 1:10 ) )
-             spectrum_y = 0.0_wp
-          ENDIF
-
-          ALLOCATE( var_d(nzb:nzt+1) )
-          var_d = 0.0_wp
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE spectra_init
+
+    USE indices,                                                                                   &
+        ONLY:  nx,                                                                                 &
+               ny,                                                                                 &
+               nzb,                                                                                &
+               nzt
+
+    IMPLICIT NONE
+
+    IF ( spectra_initialized )  RETURN
+
+    IF ( dt_dosp /= 9999999.9_wp )  THEN
+
+       IF ( .NOT. ALLOCATED( spectrum_x ) )  THEN
+          ALLOCATE( spectrum_x( 1:nx/2, 1:100, 1:10 ) )
+          spectrum_x = 0.0_wp
        ENDIF
 
-       spectra_initialized = .TRUE.
-
-    END SUBROUTINE spectra_init
-
-
-
-!------------------------------------------------------------------------------!
+       IF ( .NOT. ALLOCATED( spectrum_y ) )  THEN
+          ALLOCATE( spectrum_y( 1:ny/2, 1:100, 1:10 ) )
+          spectrum_y = 0.0_wp
+       ENDIF
+
+       ALLOCATE( var_d(nzb:nzt+1) )
+       var_d = 0.0_wp
+    ENDIF
+
+    spectra_initialized = .TRUE.
+
+ END SUBROUTINE spectra_init
+
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check spectra related quantities
-!------------------------------------------------------------------------------!
-    SUBROUTINE spectra_check_parameters
-
-       USE control_parameters,                                                 &
-           ONLY:  averaging_interval, message_string, skip_time_data_output
-
-       IMPLICIT NONE
-
-!
-!--    Check the average interval
-       IF ( averaging_interval_sp == 9999999.9_wp )  THEN
-          averaging_interval_sp = averaging_interval
-       ENDIF
-
-       IF ( averaging_interval_sp > dt_dosp )  THEN
-          WRITE( message_string, * )  'averaging_interval_sp = ',              &
-                averaging_interval_sp, ' must be <= dt_dosp = ', dt_dosp
-          CALL message( 'spectra_check_parameters', 'PA0087', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    Set the default skip time interval for data output, if necessary
-       IF ( skip_time_dosp == 9999999.9_wp )                                   &
-                                          skip_time_dosp = skip_time_data_output
-
-    END SUBROUTINE spectra_check_parameters
-
-
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE spectra_check_parameters
+
+    USE control_parameters,                                                                        &
+        ONLY:  averaging_interval,                                                                 &
+               message_string,                                                                     &
+               skip_time_data_output
+
+    IMPLICIT NONE
+
+!
+!-- Check the average interval
+    IF ( averaging_interval_sp == 9999999.9_wp )  THEN
+       averaging_interval_sp = averaging_interval
+    ENDIF
+
+    IF ( averaging_interval_sp > dt_dosp )  THEN
+       WRITE( message_string, * )  'averaging_interval_sp = ', averaging_interval_sp,              &
+                                   ' must be <= dt_dosp = ', dt_dosp
+       CALL message( 'spectra_check_parameters', 'PA0087', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
+!-- Set the default skip time interval for data output, if necessary
+    IF ( skip_time_dosp == 9999999.9_wp )  skip_time_dosp = skip_time_data_output
+
+ END SUBROUTINE spectra_check_parameters
+
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
